/*
 *
 * IA32 CPU cycle counter: Bryant & Hallaron
 *
 * Luis Paulo Santos 2006
 *
 */

// Contador de ciclos

# include <stdio.h>

void start_counter (void);
double get_counter (void);

static void access_counter (unsigned *, unsigned *);

static unsigned cyc_hi=0;
static unsigned cyc_lo=0;

static void access_counter (unsigned *hi, unsigned *lo)
{
  asm ("rdtsc; movl %%edx,%0; movl %%eax,%1"  // ler contador
       : "=r" (*hi), "=r" (*lo)               // resultados
       :                                      // sem parametros
       : "%edx", "%eax");                     // regs usados
}

// iniciar contador
void start_counter (void)
{
  access_counter (&cyc_hi, &cyc_lo);
}

// calcular ciclos
double get_counter (void)
{
  unsigned ncyc_hi, ncyc_lo;
  unsigned hi, lo, borrow;
  double result;

  // ler contador
  access_counter (&ncyc_hi, &ncyc_lo);

  // calcular diferenca
  lo = ncyc_lo - cyc_lo;
  borrow = lo > ncyc_lo;
  hi = ncyc_hi-cyc_hi-borrow;

  result = (double) (hi * (1 << 30) * 4 + lo);

  if (result < 0.0L)
    fprintf (stderr, "ERRO: numero de cilos <0\n");

  return (result);
}
