/*
 *
 * Estrutura de dados
 *
 * Luis Paulo Santos 2006
 *
 */

#include <stdlib.h>
#include <stdio.h>

#ifdef USE_FLOAT
typedef float data_t;
#else
typedef int data_t;
#endif

void data_ini (int);
void data_destroy (void);
data_t get_elem (int);
int get_length (void);
data_t * get_vec_addr (void);

static tamanho=0;
static data_t *data;

void data_ini (int n) {
  int i;

  data = (data_t *) malloc (n*sizeof(data_t));
  if (data==NULL) {
    fprintf (stderr, "ERRO: memoria insuficiente\n");
    tamanho=0;
  }
  else {

    tamanho = n;

    for (i=0; i<n ; i++) {
#ifdef USE_FLOAT
      data[i] = (data_t) (drand48()*1000.0L);
#else
      data[i] = rand ();
#endif
    }
  }
}

void data_destroy (void) {
  if (tamanho)
    free (data);
  tamanho=0;
}

data_t get_elem (int i) {
  return (data[i]);
}

int get_length (void) {
  return (tamanho);
}

data_t * get_vec_addr (void) {
  return (data);
}
